Overview | Package | Class | Use | Tree | Deprecated | Index | Help
PREV CLASS NEXT CLASS | FRAMES NO FRAMES
SUMMARY: NESTED | FIELD | CONSTR | METHOD | DETAIL: FIELD | CONSTR | METHOD

## com.atlassian.bamboo.build
Interface BuildDefinition

All Known Implementing Classes:
  DefaultBuildDefinition, LegacyBuildObject, LegacyBuildObjectFor110, LegacyTestBuildObject, UpgradeTask102BuildObject

    public interface BuildDefinition

Each build has a `BuildDefinition`. This class encapsupate the confiuguration aspects of a build. What the actual builds look like? What should be executed?

Method Summary
`void` | `addArtifact(Artifact artifact)` Add a new artifact to the existing build artifacts
`void` | `addBuildDependency(String buildKey)`
`Map` | `getArtifacts()` Get the custom `Artifact`s.
`List` | `getBuildChangedEmailList()` Who wants to know when the build changes? A list of individual email addresses.
`String` | `getBuildChangedEmails()` Who wants to know when the build changes? One or more email addresses (comma separated list)
`List` | `getBuildDependencies()` Deprecated. use `Build.getChildBuilds()` instead.
`Builder` | `getBuilder()` Obtain the build's `Builder`.
`BuildStrategy` | `getBuildStrategy()` Returns to `BuildStrategy` that the user actually selects
`Map` | `getCustomConfiguration()`
`EmailStrategy` | `getEmailStrategy()` What email strategy does this build have?
`String` | `getExportStatusStyle()`
`int` | `getPollingPeriod()` How long should we wait between checking the build to see if it need building?
`Repository` | `getRepository()` Obtain the build's `Repository`.
`XmppMessageSender` | `getXmppMessageSender()` The build's option IM message server configuration
`boolean` | `hasBuildDependency(String buildKey)`
`void` | `removeBuildDependency(String buildKey)`
`void` | `setArtifacts(Map artifacts)` Replace the build's artifacts with these ones.
`void` | `setBuildChangedEmails(String emailAddress)` Define who is notified of build results by email
`void` | `setBuildDependencies(Set buildDependencies)` Set of `String` represneting the build keys
`void` | `setBuilder(Builder builder)` Set the build's builder.
`void` | `setBuildStrategy(BuildStrategy buildStrategy)` Set the strategy to override the default build strategy.
`void` | `setCustomConfiguration(Map configMap)`
`void` | `setEmailStrategy(EmailStrategy emailStrategy)` Define when build build email need to be sent
`void` | `setExportStatusStyle(String exportStatus)`
`void` | `setPollingPeriod(int pollingPeriod)` How long should we wait between checking the build to see if it need building?
`void` | `setRepository(Repository repository)` Set the build's source code repository.
`void` | `setWorkingDirectory(String buildDirectory)` Deprecated.
`void` | `setXmppMessageSender(XmppMessageSender xmppMessageSender)` The build's option IM message server configuration

Method Detail

### getBuildStrategy

    BuildStrategy getBuildStrategy()

  Returns to `BuildStrategy` that the user actually selects

  Returns:
    the selected `BuildStrategy`

### setBuildStrategy

    void setBuildStrategy(BuildStrategy buildStrategy)

  Set the strategy to override the default build strategy.

  Parameters:
    `buildStrategy` - The next build strategy to use.

### getRepository

    Repository getRepository()

  Obtain the build's `Repository`.

  Returns:
    The Repository

### setRepository

    void setRepository(Repository repository)

  Set the build's source code repository.

  Parameters:
    `repository` - The source repoisitory

### getPollingPeriod

    int getPollingPeriod()

  How long should we wait between checking the build to see if it need building?

  Returns:
    the time in seconds

### setPollingPeriod

    void setPollingPeriod(int pollingPeriod)

  How long should we wait between checking the build to see if it need building?

  Parameters:
    `pollingPeriod` - The time in seconds

### getBuilder

    Builder getBuilder()

  Obtain the build's `Builder`.

  Returns:
    The builder

### setBuilder

    void setBuilder(Builder builder)

  Set the build's builder.

  Parameters:
    `builder` - the builder

### getBuildChangedEmails

    String getBuildChangedEmails()

  Who wants to know when the build changes? One or more email addresses (comma separated list)

  Returns:
    The build email addresses

### getBuildChangedEmailList

    List getBuildChangedEmailList()

  Who wants to know when the build changes? A list of individual email addresses.

  Returns:
    The collection of emails.

### setBuildChangedEmails

    void setBuildChangedEmails(String emailAddress)

  Define who is notified of build results by email

  Parameters:
    `emailAddress` - The build email address

### getEmailStrategy

    EmailStrategy getEmailStrategy()

  What email strategy does this build have?

### setEmailStrategy

    void setEmailStrategy(EmailStrategy emailStrategy)

  Define when build build email need to be sent

  Parameters:
    `emailStrategy` - the strategy to use from now on

### addBuildDependency

    void addBuildDependency(String buildKey)

### removeBuildDependency

    void removeBuildDependency(String buildKey)

### hasBuildDependency

    boolean hasBuildDependency(String buildKey)

### setBuildDependencies

    void setBuildDependencies(Set buildDependencies)

  Set of `String` represneting the build keys

  Parameters:
    `buildDependencies` -

### getBuildDependencies

    List getBuildDependencies()

  Deprecated. use `Build.getChildBuilds()` instead.

  The keys of the builds that need to be build when this build is built?

  Returns:
    The keys of the builds that need building

### getArtifacts

    Map getArtifacts()

  Get the custom `Artifact`s.

  Returns:
    The collection of artifacts, null, if the build does not have any artifacts

### addArtifact

    void addArtifact(Artifact artifact)

  Add a new artifact to the existing build artifacts

  Parameters:
    `artifact` -

### setArtifacts

    void setArtifacts(Map artifacts)

  Replace the build's artifacts with these ones.

  Parameters:
    `artifacts` -

### setWorkingDirectory

    void setWorkingDirectory(String buildDirectory)

  Deprecated.

  Parameters:
    `buildDirectory` -

### getXmppMessageSender

    XmppMessageSender getXmppMessageSender()

  The build's option IM message server configuration

### setXmppMessageSender

    void setXmppMessageSender(XmppMessageSender xmppMessageSender)

  The build's option IM message server configuration

### setExportStatusStyle

    void setExportStatusStyle(String exportStatus)

### getExportStatusStyle

    String getExportStatusStyle()

### getCustomConfiguration

    Map getCustomConfiguration()

### setCustomConfiguration

    void setCustomConfiguration(Map configMap)

Overview | Package | Class | Use | Tree | Deprecated | Index | Help
PREV CLASS NEXT CLASS | FRAMES NO FRAMES
SUMMARY: NESTED | FIELD | CONSTR | METHOD | DETAIL: FIELD | CONSTR | METHOD

Copyright © 2006 Atlassian Software Systems. All Rights Reserved.